## extra-cmake-modules-6.23.0-1.src.tar.gz

=== tests/ECMAddTests/CMakeLists.txt ===
if (QT_MAJOR_VERSION EQUAL "6")
    set(QT_VERSION_OPT "-DBUILD_WITH_QT6=ON")
else()
    set(QT_VERSION_OPT "-DBUILD_WITH_QT6=OFF")
endif()

macro(add_check NAME)
    string(REPLACE "." "/" dir "${NAME}")
    string(REGEX REPLACE "[^.]*\\." "" proj "${NAME}")
    add_test(
        NAME ecm_add_tests-${NAME}
        COMMAND
            ${CMAKE_CTEST_COMMAND}
            --build-and-test
            "${CMAKE_CURRENT_SOURCE_DIR}/${dir}"
            "${CMAKE_CURRENT_BINARY_DIR}/${dir}"
            --build-two-config
            --build-generator ${CMAKE_GENERATOR}
            --build-makeprogram ${CMAKE_MAKE_PROGRAM}
            --build-project ${proj}
            --build-options -DBUILD_TESTING:BOOL=ON ${QT_VERSION_OPT}
            ${${NAME}_EXTRA_OPTIONS}
            --test-command "${CMAKE_CTEST_COMMAND}"
        )
    add_test(
        NAME ecm_add_tests_did_run-${NAME}
        COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/check_files.cmake" ${ARGN}
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${dir}"
        )
    set_property(TEST ecm_add_tests_did_run-${NAME}
        APPEND
        PROPERTY DEPENDS "ecm_add_tests-${NAME}"
        )
endmacro()

macro(add_nameprefix_test NAME)
    string(REPLACE "." "/" dir "${NAME}")
    string(REGEX REPLACE "[^.]*\\." "" proj "${NAME}")
    add_test(
        NAME ecm_add_tests-${NAME}
        COMMAND
            ${CMAKE_CTEST_COMMAND}
            --build-and-test
            "${CMAKE_CURRENT_SOURCE_DIR}/${dir}"
            "${CMAKE_CURRENT_BINARY_DIR}/${dir}"
            --build-two-config
            --build-generator ${CMAKE_GENERATOR}
            --build-makeprogram ${CMAKE_MAKE_PROGRAM}
            --build-project ${proj}
            --build-options -DBUILD_TESTING:BOOL=ON
            ${${NAME}_EXTRA_OPTIONS}
            --test-command "${CMAKE_CTEST_COMMAND}"
        )
endmacro()

add_check(single_tests
    test1.txt
    test2.txt
    test3.txt
    test4.txt
    test5.txt
    test6.txt
    test7_dir/test7.txt
    )
add_check(multi_tests
    test1.txt
    test2.txt
    test3.txt
    test4.txt
    test5.txt
    test6.txt
    test7.txt
    test8.txt
    test9.txt
    test1011_dir/test10.txt
    test1011_dir/test11.txt
    )

add_nameprefix_test(nameprefix_by_var_tests)
add_nameprefix_test(nameprefix_by_path_tests)

=== tests/ECMAddTests/nameprefix_by_path_tests/dir_a/CMakeLists.txt ===
# SPDX-FileCopyrightText: None
# SPDX-License-Identifier: CC0-1.0

add_subdirectory(dir_b)
add_subdirectory(dir_ignored)
add_subdirectory(dir_notignored)
add_subdirectory(dir_bypropignored)
add_subdirectory(dir_first)
add_subdirectory(dir_renamed)
add_subdirectory(dir_nodirs)

# default from source name., prefix preset by path-derived value
ecm_add_test(
    ${main_cpp}
)

# prefix preset by path-derived value
ecm_add_test(
    TEST_NAME "main_a2"
    ${main_cpp}
)

# override of path-derived value by explicit arg
ecm_add_test(
    NAME_PREFIX "override_by_arg-"
    TEST_NAME "main_a3"
    ${main_cpp}
)

# check
assert_test_name_prefix("dir_a-")

assert_test_name("dir_a-" "main")
assert_test_name("dir_a-" "main_a2")
assert_test_name("override_by_arg-" "main_a3")

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>
# Maintainer: Antonio Rojas <arojas@archlinux.org>
# Contributor: Andrea Scarpino <andrea@archlinux.org>

pkgname=extra-cmake-modules
pkgver=6.23.0
pkgrel=1
pkgdesc='Extra modules and scripts for CMake'
arch=(any)
url='https://community.kde.org/Frameworks'
license=(LGPL)
depends=(cmake)
makedepends=(python-requests
             python-sphinx
             qt6-tools)
optdepends=('python-pyxdg: to generate fastlane metadata for Android apps'
            'python-requests: to generate fastlane metadata for Android apps'
            'python-yaml: to generate fastlane metadata for Android apps')
groups=(kf6)
source=(https://download.kde.org/stable/frameworks/${pkgver%.*}/$pkgname-$pkgver.tar.xz{,.sig})
sha256sums=('dba2d34765d09a3a5d3e95a64b9b18ae278b1dfee507cbd0a873a910a1084194'
            'SKIP')
            
validpgpkeys=(53E6B47B45CEA3E0D5B7457758D0EE648A48B3BB # David Faure <faure@kde.org>
              E0A3EB202F8E57528E13E72FD7574483BB57B18D # Jonathan Esk-Riddell <jr@jriddell.org>
              90A968ACA84537CC27B99EAF2C8DF587A6D4AAC1 # Nicolas Fella <nicolas.fella@kde.org>
              )

build() {
  cmake -B build -S $pkgname-$pkgver \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DBUILD_HTML_DOCS=ON \
    -DBUILD_QTHELP_DOCS=ON \
    -DBUILD_TESTING=OFF
  cmake --build build
}

package() {
  DESTDIR="$pkgdir" cmake --install build
}
